function WeaponFactoryTweakData:moe_setup_forbid( mod_one, mod_two )
    if self.parts[mod_one] and self.parts[mod_two] then
        self.parts[mod_one].forbids = self.parts[mod_one].forbids or {}
        table.insert(self.parts[mod_one].forbids, mod_two)
        self.parts[mod_two].forbids = self.parts[mod_two].forbids or {}
        table.insert(self.parts[mod_two].forbids, mod_one)
    end
end

Hooks:PostHook( WeaponFactoryTweakData, "init", "UnivMOEInitaddon", function(self)
	
	self.parts.wpn_fps_upg_fg_moe2_short.adds = nil
	self.parts.wpn_fps_upg_fg_moe2_short.forbids = {}

	
	-- add stock adapters to weapons that don't have them
	self.wpn_fps_smg_hajk.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_smg_mp5.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_smg_schakal.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_ass_ak5.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_smg_mac10.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_lmg_par.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_ass_fal.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_ass_asval.stock_adapter = "wpn_upg_ak_s_adapter"
	self.wpn_fps_ass_scar.stock_adapter = "wpn_upg_ak_s_adapter"

	-- forbid AK standard grip or it'll appear on weapons that shouldn't have it
	self.parts.wpn_fps_ass_fal_body_standard.forbids = self.parts.wpn_fps_ass_fal_body_standard.forbids or {}
	table.insert(self.parts.wpn_fps_ass_fal_body_standard.forbids, "wpn_upg_ak_g_standard")

	self.parts.wpn_fps_ass_asval_body_standard.forbids = self.parts.wpn_fps_ass_asval_body_standard.forbids or {}
	table.insert(self.parts.wpn_fps_ass_asval_body_standard.forbids, "wpn_upg_ak_g_standard")

	self.parts.wpn_fps_ass_scar_body_standard.forbids = self.parts.wpn_fps_ass_scar_body_standard.forbids or {}
	table.insert(self.parts.wpn_fps_ass_scar_body_standard.forbids, "wpn_upg_ak_g_standard")

	-- add VAL grip or you'll be holding onto air
	self.wpn_fps_ass_asval.override = self.wpn_fps_ass_asval.override or {}
	self.wpn_fps_ass_asval.override.wpn_fps_upg_s_m4_pts = {adds = {"wpn_fps_ass_asval_g_standard"}}
	self.wpn_fps_ass_asval.override.wpn_fps_upg_s_m4_sl = {adds = {"wpn_fps_ass_asval_g_standard"}}
	self.wpn_fps_ass_asval.override.wpn_fps_upg_s_m4_sl_c = {adds = {"wpn_fps_ass_asval_g_standard"}}
	self.wpn_fps_ass_asval.override.wpn_fps_upg_s_m4_pts_c = {adds = {"wpn_fps_ass_asval_g_standard"}}
	
	
	self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_m4_uupg_o_flipup = { unit = "units/mods/weapons/wpn_fps_upg_fg_m4_moe2/wpn_fps_m4_uupg_o_flipup_moe" }
	
	
	if BeardLib.Utils:FindMod("Magpul Attachments Pack - M4") then
		--vanilla part override to black texture
		self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_upg_m4_m_pmag = { unit = "units/mods/weapons/wpn_fps_upg_m4_m_pmag_moe/wpn_fps_upg_m4_m_pmag_black" }
		self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_upg_m4_s_pts = { unit = "units/mods/weapons/wpn_fps_upg_m4_s_pts_moe/wpn_fps_upg_m4_s_pts_black" }
		--pnag 40rnd available to other gun || will optimize later
		table.insert(self.wpn_fps_ass_ak5.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_ak5_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_corgi.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_corgi_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_komodo.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_komodo_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_l85a2.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_ass_l85a2_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_smg_hajk.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_smg_hajk_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_smg_x_hajk.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		table.insert(self.wpn_fps_smg_x_hajk_npc.uses_parts, "wpn_fps_upg_m4_m_pmag40")
		--retracted cqc stock available to other gun || will optimize later
		table.insert(self.wpn_fps_ass_74.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_74_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_ak5.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_ak5_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_akm.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_akm_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_akm_gold.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_akm_gold_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_akmsu.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_akmsu_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_saiga.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_saiga_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_r870.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_r870_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_serbu.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_shot_serbu_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_s552.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_s552_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_m249.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_m249_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_rpk.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_rpk_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_gre_m32.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_gre_m32_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_polymer.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_polymer_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_tecci.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_tecci_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_snp_tti.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_snp_tti_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_flint.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_flint_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_hajk.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_hajk_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_asval.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_asval_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_fal.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_fal_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_mac10.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_mac10_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_mp5.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_mp5_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_schakal.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_smg_schakal_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_scar.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_ass_scar_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_par.uses_parts, "wpn_fps_upg_s_m4_sl_c")
		table.insert(self.wpn_fps_lmg_par_npc.uses_parts, "wpn_fps_upg_s_m4_sl_c")
	end
	
	if BeardLib.Utils:FindMod("RSASS") then
		self.parts.wpn_fps_snp_tti_m_rsass.unit = "units/mods/weapons/wpn_fps_ass_rsass_pts/wpn_fps_rsass_mag/wpn_fps_rsass_mag"
		table.insert(self.wpn_fps_snp_tti.uses_parts, "wpn_fps_snp_tti_m_rsass")
		table.insert(self.wpn_fps_snp_tti_npc.uses_parts, "wpn_fps_snp_tti_m_rsass")
	end
	
	if BeardLib.Utils:FindMod("Standalone M16 Iron Sights") then
		self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_m4_uupg_fg_rail_ext_mod = { a_obj = "a_gb_railed_fg_moe2_short" }
		self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_ass_m16_os_frontsight_mod = { a_obj = "a_gb_frontsight_fg_moe2_short" }
        self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_ass_m16_os_frontsight = { a_obj = "a_gb_frontsight_fg_moe2_short" }
        self.parts.wpn_fps_upg_fg_moe2_short.override.wpn_fps_ass_m16_os_gas_tube = { a_obj = "a_gb_frontsight_fg_moe2_short" }
	end
	
self.wpn_fps_shot_serbu.override = self.wpn_fps_shot_serbu.override or {}
if self.parts.wpn_fps_upg_fg_r870_emo then
    self.wpn_fps_shot_serbu.override.wpn_fps_upg_fg_r870_emo = {a_obj="a_emo"}
end		

	-- if BeardLib.Utils:FindMod("Rail Covers") then
		-- table.insert(self.parts.wpn_fps_upg_fg_moe2_short.forbids, wpn_fps_m4_rc)
		-- table.insert(self.parts.wpn_fps_upg_fg_moe2_short.forbids, wpn_fps_m4_rc_nob)
		-- table.insert(self.parts.wpn_fps_upg_fg_moe2_short.forbids, wpn_fps_m4_rc_top)
		-- table.insert(self.parts.wpn_fps_upg_fg_moe2_short.forbids, wpn_fps_m4_rc_top_nob)
	-- end

end )
